## ros-noetic-ess-imu-ros1-uart-driver 1.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(ess_imu_ros1_uart_driver)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  roscpp
  sensor_msgs
  std_msgs
  geometry_msgs
  tf2
)


###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  CATKIN_DEPENDS
  roscpp
  sensor_msgs
  std_msgs
  geometry_msgs
  tf2
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(
  ${catkin_INCLUDE_DIRS}
)


# Specify compiler options
set(CMAKE_CXX_COMPILER "/usr/bin/g++")

# Default to C99
if (CMAKE_VERSION VERSION_LESS "3.1")
    if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
      set (CMAKE_C_FLAGS "-std=gnu99 ${CMAKE_C_FLAGS}")
    endif ()
else ()
    set (CMAKE_C_STANDARD 99)
endif ()

# Specify DEBUG macro to enable any debug code by adding "-DDEBUG" in add_definitions()
#add_definitions(-DDEBUG)

# Refer to the readme.txt inside the src folder for more details
# Uncomment the desired imu_model to build
#set(imu_model "G365PDF0")
#set(imu_model "G365PDF1")
#set(imu_model "G365PDC0")
#set(imu_model "G365PDC1")
#set(imu_model "G370PDF0")
set(imu_model "G370PDF1")
#set(imu_model "G325PDF0")
#set(imu_model "G325PDF1")
#set(imu_model "G354")
#set(imu_model "G364PDCA")
#set(imu_model "G364PDC0")
#set(imu_model "G320")
#set(imu_model "V340")
add_definitions(-D${imu_model})
message("---- Building for IMU Model: ${imu_model}")

# Setting macro NATIVE_QUAT enables hardware quaternion output function in G325/G365 only 
# and has no effect for any other IMU models
# If not defined then quaternion output is emulated by converting from G325/G365 Euler output using ROS tf2 library
# NATIVE_QUAT is recommended over software conversion from euler output
add_definitions(-DNATIVE_QUAT)

# Setting macro PUB_RPY enables publishing Roll Pitch Yaw output (non-moving frame) 
# in topic /epson_imu_rpy
# The PUB_RPY macro and euler output is only supported on G325/G365 only and not supported in other IMU model
# NOTE: Euler output data is emulated by converting from G325/G365 quaternion output using ROS tf2 library
# add_definitions(-DPUB_RPY)

# Create filelist of sources for C library 
set(lib_sources 
  src/hcl_gpio.c
  src/hcl_linux.c
  src/hcl_uart.c
  src/sensor_epsonCommon.c
  src/sensor_epsonUart.c
)

# Add IMU model specific source to library 
if (imu_model STREQUAL "G365PDF0")
  set(lib_sources ${lib_sources}
    src/sensor_epsonG365.c)
elseif (imu_model STREQUAL "G365PDF1")
  set(lib_sources ${lib_sources}
    src/sensor_epsonG365.c)
elseif (imu_model STREQUAL "G365PDC0")
  set(lib_sources ${lib_sources}
    src/sensor_epsonG365.c)
elseif (imu_model STREQUAL "G365PDC1")
  set(lib_sources ${lib_sources}
    src/sensor_epsonG365.c)
elseif (imu_model STREQUAL "G370PDF0")
  set(lib_sources ${lib_sources}
    src/sensor_epsonG370.c)
elseif (imu_model STREQUAL "G370PDF1")
  set(lib_sources ${lib_sources}
    src/sensor_epsonG370.c)
elseif (imu_model STREQUAL "G325PDF0")
  set(lib_sources ${lib_sources}
    src/sensor_epsonG325.c)
elseif (imu_model STREQUAL "G325PDF1")
  set(lib_sources ${lib_sources}
    src/sensor_epsonG325.c)
elseif (imu_model STREQUAL "G354")
  set(lib_sources ${lib_sources}
    src/sensor_epsonG354.c)
elseif (imu_model STREQUAL "G364PDCA")
  set(lib_sources ${lib_sources}
    src/sensor_epsonG364.c)
elseif (imu_model STREQUAL "G364PDC0")
  set(lib_sources ${lib_sources}
    src/sensor_epsonG364.c)
elseif (imu_model STREQUAL "G320")
  set(lib_sources ${lib_sources}
    src/sensor_epsonG320.c)
elseif (imu_model STREQUAL "V340")
  set(lib_sources ${lib_sources}
    src/sensor_epsonV340.c)
else()
  message([FATAL_ERROR] "**** Invalid IMU Model")
endif()

# Declare a library for Epson IMU functions from C sources
add_library(ess_imu_ros1_uart_driver
  ${lib_sources}
)

# Declare a C++ executable
add_executable(ess_imu_ros1_uart_driver_node
  src/epson_imu_uart_driver_node.cpp
)

# Link epson C library to executable target ROS node
target_link_libraries(ess_imu_ros1_uart_driver_node
  ${catkin_LIBRARIES}
  ess_imu_ros1_uart_driver
)

#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(TARGETS ess_imu_ros1_uart_driver_node
   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

=== src/Makefile ===
CC=g++

DEFINES= -D$(MODEL)
INCLUDES= .
CFLAGS= -I$(INCLUDES) $(DEFINES) -Wall
LIBS=
DEPS= hcl.h hcl_gpio.h sensor_epsonCommon.h main_helper.h
DEPS_IMUMODEL= sensor_epsonG354.h sensor_epsonG364PDC0.h sensor_epsonG364PDCA.h sensor_epsonV340.h sensor_epsonG320.h sensor_epsonG365PDC0.h sensor_epsonG365PDF0.h sensor_epsonG370PDF0.h sensor_epsonG325PDF0.h sensor_epsonG365PDC1.h sensor_epsonG365PDF1.h sensor_epsonG370PDF1.h sensor_epsonG325PDF1.h
DEPS_UART= hcl_uart.h

_OBJ= hcl_gpio.o hcl_linux.o hcl_uart.o sensor_epsonCommon.o sensor_epsonUart.o main_helper.o
# If no MODEL macro is defined when calling make it defaults to G365PDF0
MODEL ?= G365PDF0

####### Adding MODEL Specific Files
ifeq ($(MODEL), G354)
	_OBJ+= sensor_epsonG354.o
endif

ifeq ($(MODEL), G364PDC0)
	_OBJ+= sensor_epsonG364.o
endif

ifeq ($(MODEL), G364PDCA)
	_OBJ+= sensor_epsonG364.o
endif

ifeq ($(MODEL), V340)
	_OBJ+= sensor_epsonV340.o
endif

ifeq ($(MODEL), G320)
	_OBJ+= sensor_epsonG320.o
endif

ifeq ($(MODEL), G365PDC0)
	_OBJ+= sensor_epsonG365.o
endif

ifeq ($(MODEL), G365PDF0)
	_OBJ+= sensor_epsonG365.o
endif

ifeq ($(MODEL), G370PDF0)
	_OBJ+= sensor_epsonG370.o
endif

ifeq ($(MODEL), G325PDF0)
	_OBJ+= sensor_epsonG325.o
endif

ifeq ($(MODEL), G365PDC1)
	_OBJ+= sensor_epsonG365.o
endif

ifeq ($(MODEL), G365PDF1)
	_OBJ+= sensor_epsonG365.o
endif

ifeq ($(MODEL), G370PDF1)
	_OBJ+= sensor_epsonG370.o
endif

ifeq ($(MODEL), G325PDF1)
	_OBJ+= sensor_epsonG325.o
endif

OBJ_SCREEN= main_screen.o $(_OBJ)
OBJ_CSV= main_csvlogger.o $(_OBJ)
OBJ_REG= main_regdump.o $(_OBJ)

%.o: %.c $(DEPS) $(DEPS_UART) $(DEPS_IMUMODEL)
	$(CC) -c -o $@ $< $(CFLAGS) $(LIBS)

screen: $(OBJ_SCREEN)
	$(CC) -o $@ $^ $(CFLAGS) $(LIBS)

csvlogger: $(OBJ_CSV)
	$(CC) -o $@ $^ $(CFLAGS) $(LIBS)

regdump: $(OBJ_REG)
	$(CC) -o $@ $^ $(CFLAGS) $(LIBS)

.PHONY: clean all tar help

clean:
	rm -f *.o *~ core *~
	rm -f csvlogger screen regdump

all: screen csvlogger regdump

tar:
	tar cvzf archive.tar.gz *.c *.h readme.txt Makefile

help:
	@echo "supported make commands are:"
	@echo "\tmake clean"
	@echo "\tmake <targets> MODEL=<model>\n"
	@echo "valid <targets> are: csvlogger screen or regdump\n"
	@echo "valid <models> are:"
	@echo "\tG354 G364PDC0 G364PDCA G320 V340 G365PDC0 G365PDF0(default) G370PDF0 G325PDF0"
	@echo "\tG365PDC1 G365PDF1 G370PDF1 G325PDF1\n"
	@echo "example:\n\tmake csvlogger MODEL=G364PDC0"
	@echo "\tmake screen (defaults to MODEL=G365PDF0)"

=== debian/changelog ===
ros-noetic-ess-imu-ros1-uart-driver (1.3.2-1buster) buster; urgency=high

  * update cmake_minimum_required to avoid unstable build on buildfarm due to CMP0048 warning
  * update README.md for name change in package.xml, CMakeLists.txt
  * add dependency geometry_msgs and tf2
  * fix for name change in package.xml, CMakeLists.txt, launch files
  * Cleanup description of applicable licensing for files BSD-3 and Public Domain

 -- Raymond Chow <raymond.chow@ea.epson.com>  Wed, 03 Aug 2022 07:00:00 -0000

ros-noetic-ess-imu-ros1-uart-driver (1.3.1-1buster) buster; urgency=high

  * release 1st time
  * renamed from package from epson_imu_uart_driver

 -- John Keller <jkeller2@andrew.cmu.edu>  Tue, 19 Jul 2022 07:00:00 -0000

=== debian/control ===
Source: ros-noetic-ess-imu-ros1-uart-driver
Section: misc
Priority: optional
Maintainer: Raymond Chow <raymond.chow@ea.epson.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-geometry-msgs, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-tf2
Homepage: https://wiki.ros.org/ess_sensors/ros1uart
Standards-Version: 3.9.2

Package: ros-noetic-ess-imu-ros1-uart-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-geometry-msgs, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-tf2
Description: The Epson IMU Driver using UART interface for ROS package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-ess-imu-ros1-uart-driver//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
